import pandas as pd
from common import create_parser, plot_benchmark_data

common_argparser = create_parser()
# Parse the arguments
args = common_argparser.parse_args()

# Define file paths
brute_algo_path = args.BruteAlgoFile
tree_algo_path = args.TreeAlgoFile


# Load and process data
brute_algo_data = (
    pd.read_csv(brute_algo_path, index_col=0, header=None, delimiter=";").T / 1000
)  

# Convert to seconds
tree_algo_data = (
    pd.read_csv(tree_algo_path, index_col=0, header=None, delimiter=";").T / 1000
)

(N_ITER, N) = brute_algo_data.shape

brute_mean = brute_algo_data.mean()
tree_mean = tree_algo_data.mean()

xaxis = list(range(1, N + 1))
brute_mean.index = pd.Index(list(range(1, N + 1)))
tree_mean.index = pd.Index(list(range(1, N + 1)))

MAX_PRODS_CONS = N 

plot_benchmark_data(
    brute_algo_data,
    tree_algo_data,
    1000,
    f"Benchmark with upto {MAX_PRODS_CONS} producers/consumers and buffer size 1000",
    "Number of producers and consumers",
    "./plots/BoundedBufferBenchmark_Figure_4_V2",
    x_ticks=xaxis,
)